<template>
  <header class="header">
    <div class="container">
      <div class="header__content">
        <div class="header__top">

          <Logo />

          <nav class="header__nav nav">
            <ul class="nav__list">
              <li class="nav__item"><NuxtLink to="contacts" class="nav__link">Про нас</NuxtLink></li>
              <li class="nav__item"><NuxtLink to="contacts" class="nav__link">Контакти</NuxtLink></li>
              <li class="nav__item"><NuxtLink to="contacts" class="nav__link">Доставка і оплата</NuxtLink></li>
              <li class="nav__item"><NuxtLink to="contacts" class="nav__link">Повернення і обмін</NuxtLink></li>
            </ul>
          </nav>
          <div class="header__contact">
            <div class="contact__phone">
              <p class="phone__header phone">(063) 128-46-09</p>
            </div>

            <Social />

            <div class="language">
              <button class="language__change language__current">Укр</button>
              <span>|</span>
              <button class="language__change">Рус</button>
            </div>
            <div class="header__login">
              <NuxtLink :to="`${ store.checkLogin ? '/account' : '/auth'}`" class="user-menu__link">
                <BaseIconSvg iconName="user" />
                <span class="header__login--name">{{ store.checkLogin ? "Кабінет" : "Вхід" }}</span>
                
                
              </NuxtLink>
            </div>
          </div>
        </div>
        <div class="header__bottom">

          <Catalog />

          <div class="header__menu">
            <div class="header__tablet-menu">
              <button class="catalog__tablet" @click="catalogTabletMethod">
                <div class="catalog__burger">
                  <span></span>
                  <span></span>
                  <span></span>
                </div>
              </button>

              <Logo class="logo-media" />

              <div class="catalog__tablet-popup" v-if="catalogTablet">
                <button class="catalog__top catalog__top--tablet" @click="catalogPopupMethod">
                  <div class="catalog__burger catalog__burger--tablet">
                    <span></span>
                    <span></span>
                    <span></span>
                  </div>
                  <div class="catalog__name">
                    <p class="catalog__name--head">
                      Каталог
                    </p>
                  </div>
                </button>

                <div class="catalog__bottom catalog__bottom--tablet" v-if="catalogPopup">
                  
                  <ul class="catalog__list">
                    <div>
                      <button @click="catalogPopupMethod" class="catalog__bottom--btn" href=""><span class="catalog__bottom--arrow"></span>Меню</button>
                    </div>
                    <li class="catalog__item"><a href="catalog.html" class="catalog__link">
                        <div class="catalog__image">
                          <img src="/img/carriage.svg" alt="carriage" class="catalog__item--icon">
                        </div>
                        Дитячі коляски
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image">
                          <img src="/img/room.svg" alt="room" class="catalog__item--icon">
                        </div>
                        Дитяча кімната
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image">
                          <img src="/img/chair.svg" alt="chair" class="catalog__item--icon">
                        </div>

                        Стільці і шезлонги
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image">
                          <img src="/img/feeding.svg" alt="feeding" class="catalog__item--icon">
                        </div>

                        Для годування
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image"><img src="/img/soap.svg" alt="soap" class="catalog__item--icon">
                        </div>

                        Гігієна і догляд
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image"><img src="/img/autochair.svg" alt="autochair"
                            class="catalog__item--icon"></div>

                        Автокрісла
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image"><img src="/img/car.svg" alt="car" class="catalog__item--icon"></div>

                        Дитячий транспорт
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image"><img src="/img/toy.svg" alt="toy" class="catalog__item--icon"></div>

                        Іграшки
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image"><img src="/img/clothes.svg" alt="clothes"
                            class="catalog__item--icon"></div>

                        Одяг
                      </a></li>
                    <li class="catalog__item"><a href="#" class="catalog__link">
                        <div class="catalog__image"><img src="/img/new.svg" alt="new" class="catalog__item--icon"></div>

                        Новий товар
                      </a></li>
                  </ul>
                </div>

                <ul class="footer__about footer__about--tablet">
                  <li class="about__item">
                    <NuxtLink to="contacts" class="about__link">Про нас</NuxtLink>
                  </li>
                  <li class="about__item">
                    <nuxt--link to="contacts" class="about__link">Контакти</nuxt--link>
                  </li>
                  <li class="about__item">
                    <NuxtLink to="contacts" class="about__link">Доставка і оплата</NuxtLink>
                  </li>
                  <li class="about__item">
                    <NuxtLink to="contacts" class="about__link">Повернення і обмін</NuxtLink>
                  </li>

                </ul>



                <div class="header__contact  header__contact--tablet">
                  <div class="contact__phone">
                    <p class="phone__header phone">(063) 128-46-09</p>

                  </div>

                  <Social />

                  <div class="language language--tablet">
                    <button class="language__change language__current">Укр</button>
                    <span>|</span>
                    <button class="language__change">Рус</button>
                  </div>
                  <div class="header__login">
                    <NuxtLink to="/signin" class="user-menu__link">
                      <BaseIconSvg iconName="user" />
                      <span class="header__login--name">Вхід</span>
                    </NuxtLink>
                  </div>
                </div>
              </div>

            </div>
          </div>
          <div class="search__block">
            <BaseLoader v-model="loader">
              <vee-form @click="searchPopupMethod" class="search" name="search">

                <InputText customClass="input--search" name="q" placeholder="Я шукаю..." v-model="formData.q" />

                <button type="submit" @click.prevent="getPruductsBySearch" class="btn--search">
                  <BaseIconSvg width="16px" height="16px" iconName="search" />
                </button>
              </vee-form>
            </BaseLoader>
            <div :class="['search__popup', {'search__popup--display' : !searchPopup}]">
              <SearchProducts :options="productItems" />
              <p v-if="productItems.length < 1" style="color: black;">{{ searchMessage }}</p>
            </div>
          </div>
          <div class="user-menu">
            <ul class="user-menu__list">
              <li class="user-menu__item user-menu__search"><a href="#" class="user-menu__link">
                  <BaseIconSvg iconName="search-modale" />
                </a></li>
              <li class="user-menu__item"><NuxtLink to="/compare" class="user-menu__link">
                  <BaseIconSvg width="29px" height="20px" iconName="comparison" />
                  <span class="counter counter__circle">0</span>
                </NuxtLink></li>
              <li class="user-menu__item"><a href="#" class="user-menu__link">
                  <BaseIconSvg width="23px" height="20px" iconName="favorite" />
                  <span class="counter counter__circle">0</span>
                </a></li>
              <li v-click-out-side="customMethod" class="user-menu__item">
                <a class="user-menu__link user-menu__basket" @click="basketPopupMethod">

                  <BaseIconSvg width="27px" height="20px" iconName="basket" />
                  <span class="counter counter__circle counter--active">{{ basketItems.length }}</span>

                </a>
                <div class="user-menu__popup" v-if="basketPopup">

                  <BasketCart customClass @clickIsHere="clickHandler" :options="basketItems" />

                  <div class="basket__order">
                    <div class="basket__enter">
                      <p class="basket__order--name">Сума:</p>
                      <p class="basket__order--sum">{{sumTotalBasket}} грн</p>
                    </div>
                    <div class="basket__select">
                      <NuxtLink to="/checkout" class="button button--order">Оформити замовлення</NuxtLink>
                      <NuxtLink to="/basket" class="button btn__basket--popup">Перейти в кошик</NuxtLink>
                    </div>
                  </div>
                </div>
              </li>
            </ul>

          </div>
        </div>
      </div>
    </div>
  </header>
</template>

<script setup>

import { clickOutSide as vClickOutSide } from '@mahdikhashan/vue3-click-outside';

const props = defineProps({
  tokens: {
    type: Boolean,
    default: false,
  },
});

function customMethod() {
  basketPopup.value = false;
}

const productItems = ref([])




let catalogPopup = ref(false);

let basketPopup = ref(false);

let searchPopup = ref(false)

let catalogTablet = ref(false);

const token = useCookie("token");


import { useForm, useField } from 'vee-validate';
import * as yup from 'yup';
import { boolean } from 'yup/lib/locale';


const store = $store().checkLogin;

const searchMessage = ref("Скористайтесь пошуком")

function checkSearchData() {
  if(productItems.value.length < 1) {
    searchMessage.value = "За вашим запитом товари відсутні"
  }
}


function searchPopupMethod() {
  searchPopup.value = !searchPopup.value
}

function basketPopupMethod() {
  basketPopup.value = !basketPopup.value
}

function catalogTabletMethod() {
  catalogTablet.value = !catalogTablet.value
}

function catalogPopupMethod() {
  catalogPopup.value = !catalogPopup.value
}



const formData = ref({
  q: ""
});


const { $snotify, moment } = useNuxtApp()
const loader = ref(false);

const sumTotalBasket = ref(null)
let basketItems = ref([
    
]);

async function getPruductsBySearch() {
  try {
    loader.value = true;
    const searchCarts = await $api().variations.variationGetProductsBySearch(formData.value)

    productItems.value = searchCarts.data

    checkSearchData()

    
  }
  catch(e) {
    $snotify.error(e.data);
  }
  finally {
    loader.value = false;
  }
}

async function getCarts() {
    try {
        const shopCarts = await $api().carts.getCarts()
        basketItems.value = shopCarts.data.purchases

        sumTotalBasket.value = shopCarts.total.total
    }
    catch (e) {
        
    }
}

function clickHandler() {
    getCarts()
} 

onMounted(() => {

    getCarts();

})





</script>